
Ryzom - Bug # 847

Status: Closed Priority: Normal
Author: guepe Category: Services: General
Created: 05/07/2010 Assignee: vl
Updated: 05/28/2010 Due date:
Subject: ai_outpost.cpp in x86-64 does not compile - cast to uint32
Description

In ai_outpost.cpp there are assumptions about target architecture (32bits), which raises an error when compiling in 64bits.

ai_outpost.cpp:897: erreur: cast from ‘CGroupNpc*’ to ‘uint32’ loses precision
ai_outpost.cpp: In member function ‘void COutpost::spawnSquad(uint32)’:
ai_outpost.cpp:914: erreur: cast from ‘CGroupNpc*’ to ‘uint32’ loses precision
ai_outpost.cpp:935: erreur: cast from ‘CGroupNpc*’ to ‘uint32’ loses precision
ai_outpost.cpp: In member function ‘void COutpost::despawnSquad(uint32)’:
ai_outpost.cpp:951: erreur: cast from ‘CGroupNpc*’ to ‘uint32’ loses precision
ai_outpost.cpp: In member function ‘void COutpost::deleteSquad(uint32)’:
ai_outpost.cpp:976: erreur: cast from ‘CGroupNpc*’ to ‘uint32’ loses precision
ai_outpost.cpp: In member function ‘void COutpost::sendOutpostSquadStatus(CGroupNpc*)’:
ai_outpost.cpp:991: erreur: cast from ‘CGroupNpc*’ to ‘uint32’ loses precision
ai_outpost.cpp: In member function ‘void COutpost::squadLeaderDied(CGroupNpc*)’:
ai_outpost.cpp:1014: erreur: cast from ‘CGroupNpc*’ to ‘uint32’ loses precision
ai_outpost.cpp: In member function ‘void COutpost::squadDied(CGroupNpc*)’:
ai_outpost.cpp:1024: erreur: cast from ‘CGroupNpc*’ to ‘uint32’ loses precision

Changing unint32 to size_t should make it compile, but there are aother errors, in other files. I am checking them.

History
#1 - 05/09/2010 01:23 pm - thorbjorn

This is either a duplicate or a subtask of bug #853. Unfortunately since these uint32 are used as group ID, it is probably not as easy as changing the
casts (assuming the group ID needs to be unique).

#2 - 05/12/2010 01:29 pm - kervala
- Status changed from New to Rejected

Thanks for reporting :)

#3 - 05/12/2010 01:30 pm - kervala
- Status changed from Rejected to New

#4 - 05/28/2010 05:12 pm - vl
- Status changed from New to Assigned
- Assignee set to vl
- Target version set to Version 0.8.0
The current solution is to downcast the 64b pointer into 32b.

The probability to have a group id conflict is negligible.

We cannot change the type of the groupid because the groupid is streamed on network between different services.

#5 - 05/28/2010 05:17 pm - vl
- Category set to Services: General

#6 - 05/28/2010 05:19 pm - vl
- Status changed from Assigned to Resolved
- % Done changed from 0 to 100

Applied in changeset r235.

#7 - 05/28/2010 05:23 pm - vl
- Status changed from Resolved to Closed
